Index: /LMDZ4/trunk/libf/phylmd/ini_histmthNMC.h
===================================================================
--- /LMDZ4/trunk/libf/phylmd/ini_histmthNMC.h	(revision 643)
+++ /LMDZ4/trunk/libf/phylmd/ini_histmthNMC.h	(revision 644)
@@ -4,6 +4,8 @@
       IF (ok_mensuel) THEN
 c
-         zsto = dtime
-         zout = dtime * ecrit_mth
+       zstophy = dtime
+       zstohf = dtime * FLOAT(ecrit_hf)
+       zstomth = dtime * FLOAT(ecrit_mth)
+       zout = dtime * FLOAT(ecrit_mth)
 c
          idayref = day_ref
@@ -22,61 +24,155 @@
      .                 1,iim,1,jjmp1, itau_phy, zjulian, dtime, 
      .                 nhori, nid_nmc)
-         write(*,*)'Mensuel NMC ', itau_phy, zjulian
+c
          CALL histvert(nid_nmc, "presnivs", "Vertical levels", "mb",
-     .                 klev, presnivs, nvert)
-c        call histvert(nid_nmc, 'sig_s', 'Niveaux sigma','-',
-c    .              klev, znivsig, nvert)
+     .                 nlevSTD, rlevSTD/100., nvert)
+ccc
+ccc Champs 3D interpolles sur des niveaux de pression du NMC
+ccc
+      IF(type_run.EQ."ENSP".OR.type_run.EQ."CLIM") THEN
 c
-c Champs 2D:
-
-c Champs interpolles sur des niveaux de pression du NMC
-c IMIMIM 110304 BEG
+          CALL histdef(nid_nmc, "temp",
+     .                 "Temperature","K",
+     .                iim,jjmp1,nhori, nlevSTD,1,nlevSTD, nvert, 32,
+     .                "inst(X)", zout,zout)
 c
-         DO k=1, nlevSTD
+         CALL histdef(nid_nmc, "phi",
+     .                "Geopotential", "m",
+     .                iim,jjmp1,nhori, nlevSTD,1,nlevSTD, nvert, 32,
+     .                "inst(X)", zout,zout)
 c
-         bb=clevSTD(k)
+          CALL histdef(nid_nmc, "q",
+     .                 "Specific humidity","kg/kg",
+     .                iim,jjmp1,nhori, nlevSTD,1,nlevSTD, nvert, 32,
+     .                "inst(X)", zout,zout)
 c
-         IF(k.GE.2) THEN
-          aa=clevSTD(k)
-          bb=aa(1:lnblnk1(aa))
-         ENDIF 
+         CALL histdef(nid_nmc, "rh",
+     .                 "Relative humidity", "%",
+     .                iim,jjmp1,nhori, nlevSTD,1,nlevSTD, nvert, 32,
+     .                "inst(X)", zout,zout)
 c
-          CALL histdef(nid_nmc, "t"//bb,
-     .                 "Temperature"//bb//"mb","K",
-     .                iim,jjmp1,nhori, 1,1,1, -99, 32,
-     .                "ave(X)", zsto,zout)
+          CALL histdef(nid_nmc, "u",
+     .                 "Zonal wind","m/s",
+     .                iim,jjmp1,nhori, nlevSTD,1,nlevSTD, nvert, 32,
+     .                "inst(X)", zout,zout)
 c
-         CALL histdef(nid_nmc, "phi"//bb,
-     .                "Geopotential"//bb//"mb", "m2/s2",
-     .                iim,jjmp1,nhori, 1,1,1, -99, 32,
-     .                "ave(X)", zsto,zout)
+          CALL histdef(nid_nmc, "v",
+     .                 "Meridional wind","m/s",
+     .                iim,jjmp1,nhori, nlevSTD,1,nlevSTD, nvert, 32,
+     .                "inst(X)", zout,zout)
 c
-          CALL histdef(nid_nmc, "q"//bb,
-     .                 "Specific humidity"//bb//"mb","kg/kg",
-     .                iim,jjmp1,nhori, 1,1,1, -99, 32,
-     .                "ave(X)", zsto,zout)
+      ELSE IF(type_run.EQ."AMIP".OR.type_run.EQ."CFMI") THEN
 c
-         CALL histdef(nid_nmc, "rh"//bb,
-     .                 "Relative humidity"//bb//"mb", "%",
-     .                iim,jjmp1,nhori, 1,1,1, -99, 32,
-     .                "ave(X)", zsto,zout)
+c ATTENTION : pour AMIP2 on interpole t,u,v,wphi,q,rh
+c             sur les niveaux du NMC et on somme & moyenne
+c             toutes les 6 heures par des routines undefSTD et
+c             moy_undefSTD pour eliminer les valeurs "undef"
+c             de la moyenne mensuelle
+c ======> le "inst(X)" ci-dessous est par consequence factice !
 c
-          CALL histdef(nid_nmc, "u"//bb,
-     .                 "Zonal wind"//bb//"mb","K",
-     .                iim,jjmp1,nhori, 1,1,1, -99, 32,
-     .                "ave(X)", zsto,zout)
+          CALL histdef(nid_nmc, "temp",
+     .                 "Temperature","K",
+     .                iim,jjmp1,nhori, nlevSTD,1,nlevSTD, nvert, 32,
+     .                "inst(X)", zout,zout)
 c
-          CALL histdef(nid_nmc, "v"//bb,
-     .                 "Meridional wind"//bb//"mb","K",
-     .                iim,jjmp1,nhori, 1,1,1, -99, 32,
-     .                "ave(X)", zsto,zout)
+         CALL histdef(nid_nmc, "phi",
+     .                "Geopotential ", "m",
+     .                iim,jjmp1,nhori, nlevSTD,1,nlevSTD, nvert, 32,
+     .                "inst(X)", zout,zout)
 c
-         ENDDO !nlevSTD
-c IMIMIM 110304 END
+          CALL histdef(nid_nmc, "q",
+     .                 "Specific humidity","kg/kg",
+     .                iim,jjmp1,nhori, nlevSTD,1,nlevSTD, nvert, 32,
+     .                "inst(X)", zout,zout)
+c
+         CALL histdef(nid_nmc, "rh",
+     .                 "Relative humidity", "%",
+     .                iim,jjmp1,nhori, nlevSTD,1,nlevSTD, nvert, 32,
+     .                "inst(X)", zout,zout)
+c
+          CALL histdef(nid_nmc, "u",
+     .                 "Zonal wind","m/s",
+     .                iim,jjmp1,nhori, nlevSTD,1,nlevSTD, nvert, 32,
+     .                "inst(X)", zout,zout)
+c
+          CALL histdef(nid_nmc, "v",
+     .                 "Meridional wind","m/s",
+     .                iim,jjmp1,nhori, nlevSTD,1,nlevSTD, nvert, 32,
+     .                "inst(X)", zout,zout)
+c
+          CALL histdef(nid_nmc, "w",
+     .                 "Vertical motion","Pa/s",
+     .                iim,jjmp1,nhori, nlevSTD,1,nlevSTD, nvert, 32,
+     .                "inst(X)", zout,zout)
+c
+c ATTENTION : pour AMIP2 on interpole t,u,v,wphi,q,rh
+c             sur les niveaux du NMC et on somme & moyenne
+c             toutes les 6 heures par des routines undefSTD et
+c             moy_undefSTD pour eliminer les valeurs "undef"
+c             de la moyenne mensuelle
+c ======> le "inst(X)" ci-dessus est par consequence factice !
+c
+c
+          CALL histdef(nid_nmc, "psbg",
+     .         "Pressure sfce below ground","%",
+     .         iim,jjmp1,nhori, nlevSTD,1,nlevSTD, nvert, 32,
+     .         "inst(X)", zout,zout)
+c
+          CALL histdef(nid_nmc, "uv",
+     .         "uv ",
+     .         "m2/s2",iim,jjmp1,nhori, nlevSTD,1,nlevSTD, nvert, 32,
+     .         "inst(X)", zout,zout)
+c
+          CALL histdef(nid_nmc, "vq",
+     .         "vq ",
+     .         "m/s * (kg/kg)",iim,jjmp1,nhori, 
+     .          nlevSTD,1,nlevSTD, nvert, 32,
+     .         "inst(X)", zout,zout)
+c
+          CALL histdef(nid_nmc, "vT",
+     .         "vT ", 
+     .         "mK/s",iim,jjmp1,nhori, 
+     .          nlevSTD,1,nlevSTD, nvert, 32,
+     .         "inst(X)", zout,zout)
+c
+          CALL histdef(nid_nmc, "wq",
+     .         "wq ", 
+     .         "(Pa/s)*(kg/kg)",iim,jjmp1,nhori,
+     .          nlevSTD,1,nlevSTD, nvert, 32,
+     .         "inst(X)", zout,zout)
+c
+          CALL histdef(nid_nmc, "vphi",
+     .         "vphi ", 
+     .         "m2/s",iim,jjmp1,nhori, 
+     .          nlevSTD,1,nlevSTD, nvert, 32,
+     .         "inst(X)", zout,zout)
+c
+          CALL histdef(nid_nmc, "wT",
+     .         "wT ", 
+     .         "K*Pa/s",iim,jjmp1,nhori,
+     .          nlevSTD,1,nlevSTD, nvert, 32,
+     .         "inst(X)", zout,zout)
+c
+          CALL histdef(nid_nmc, "uxu",
+     .         "u2 ", 
+     .         "m2/s2",iim,jjmp1,nhori,
+     .          nlevSTD,1,nlevSTD, nvert, 32,
+     .         "inst(X)", zout,zout)
+c
+          CALL histdef(nid_nmc, "vxv",
+     .         "v2 ", 
+     .         "m2/s2",iim,jjmp1,nhori,
+     .          nlevSTD,1,nlevSTD, nvert, 32,
+     .         "inst(X)", zout,zout)
+c
+          CALL histdef(nid_nmc, "TxT",
+     .         "T2 ", 
+     .         "K2",iim,jjmp1,nhori,
+     .          nlevSTD,1,nlevSTD, nvert, 32,
+     .         "inst(X)", zout,zout)
+c
+      ENDIF !(type_run.EQ."AMIP")
 
          CALL histend(nid_nmc)
 c
-c        ndex2d = 0
-c
       ENDIF ! fin de test sur ok_mensuel
-
Index: /LMDZ4/trunk/libf/phylmd/ini_undefSTD.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/ini_undefSTD.F	(revision 644)
+++ /LMDZ4/trunk/libf/phylmd/ini_undefSTD.F	(revision 644)
@@ -0,0 +1,81 @@
+      SUBROUTINE ini_undefSTD(nlevSTD,itap,
+     $           ecrit_day,ecrit_mth,
+     $           tnondef,tsumSTD)
+      IMPLICIT none
+c
+c====================================================================
+c
+c I. Musat : 09.2004
+c
+c Initialisation - a des frequences differentes : 
+c
+c 1) des variables moyennees sur la journee "day" ou sur le mois "mth"
+c    calculees a partir des valeurs "instantannees" de la physique
+c
+c 2) des variables moyennes mensuelles "NMC" calculees a partir des val.
+c    toutes les 6 heures
+c
+c nout=1 !var. journaliere "day" moyenne sur tous les pas de temps
+c              ! de la physique
+c nout=2 !var. mensuelle "mth" moyennee sur tous les pas de temps
+c              ! de la physique
+c nout=3 !var. mensuelle "NMC" moyennee toutes les 6heures
+c
+c
+c NB: mettre "inst(X)" dans le write_histXXX.h !
+c====================================================================
+c
+#include "dimensions.h"
+      integer jjmp1
+      parameter (jjmp1=jjm+1-1/jjm)
+#include "dimphy.h"
+c variables Input/Output
+      INTEGER nlevSTD, klevSTD, itap
+      PARAMETER(klevSTD=17)
+      INTEGER ecrit_day,ecrit_mth
+c
+c variables locales
+      INTEGER i, k, nout
+      PARAMETER(nout=3) !nout=1 day/nout=2 mth/nout=3 NMC
+c
+c variables Output
+      REAL tnondef(klon,klevSTD,nout)
+      REAL tsumSTD(klon,klevSTD,nout)
+c
+c initialisation variables journalieres en debut de journee
+c
+      IF(MOD(itap,ecrit_day).EQ.1.) THEN
+       DO k=1, nlevSTD
+        DO i=1, klon
+         tnondef(i,k,1)=0.
+         tsumSTD(i,k,1)=0.
+        ENDDO !i
+       ENDDO !k
+      ENDIF
+c
+c initialisation variables mensuelles (calculees a chaque pas de temps) 
+c en debut de mois : nout=2
+c
+      IF(MOD(itap,ecrit_mth).EQ.1.) THEN
+c
+       DO k=1, nlevSTD
+        DO i=1, klon
+         tnondef(i,k,2)=0.
+         tsumSTD(i,k,2)=0.
+        ENDDO !i
+       ENDDO !k
+c
+c initialisation variables mensuelles - runs type Amip - (calculees toutes les 6h)
+c en debut de mois : nout = 3
+c
+       DO k=1, nlevSTD
+        DO i=1, klon
+         tnondef(i,k,3)=0.
+         tsumSTD(i,k,3)=0.
+        ENDDO !i
+       ENDDO !k
+c
+      ENDIF
+c
+      RETURN
+      END  
Index: /LMDZ4/trunk/libf/phylmd/interface_surf.F90
===================================================================
--- /LMDZ4/trunk/libf/phylmd/interface_surf.F90	(revision 643)
+++ /LMDZ4/trunk/libf/phylmd/interface_surf.F90	(revision 644)
@@ -74,5 +74,7 @@
       & evap, fluxsens, fluxlat, dflux_l, dflux_s, &              
       & tsol_rad, tsurf_new, alb_new, alblw, emis_new, &
-      & z0_new, pctsrf_new, agesno,fqcalving,ffonte, run_off_lic_0)
+      & z0_new, pctsrf_new, agesno,fqcalving,ffonte, run_off_lic_0,&
+!IM "slab" ocean
+      & flux_o, flux_g, tslab, seaice)
 
 
@@ -125,4 +127,7 @@
 !   albedo       albedo de la surface
 !   tsurf        temperature de surface
+!   tslab        temperature slab ocean
+!   pctsrf_slab  pourcentages (0-1) des sous-surfaces dans le slab
+!   tmp_pctsrf_slab = pctsrf_slab
 !   p1lay        pression 1er niveau (milieu de couche)
 !   ps           pression au sol
@@ -179,4 +184,9 @@
   real, dimension(klon), intent(IN) :: ps, albedo
   real, dimension(klon), intent(IN) :: tsurf, p1lay
+!IM: "slab" ocean
+  real, dimension(klon), intent(INOUT) :: tslab
+  real, allocatable, dimension(:), save :: tmp_tslab
+  real, dimension(klon), intent(OUT) :: flux_o, flux_g
+  real, dimension(klon), intent(INOUT)        :: seaice ! glace de mer (kg/m2)
   REAL, DIMENSION(klon), INTENT(INOUT) :: radsol,fder
   real, dimension(klon), intent(IN) :: zmasq
@@ -212,4 +222,14 @@
 !jld a rajouter   real, dimension(klon), intent(INOUT):: fqcalving
   real, dimension(klon), intent(INOUT):: fqcalving
+!IM: "slab" ocean
+  real, dimension(klon) :: new_dif_grnd 
+!IM: "slab" ocean - Local
+  real, parameter :: t_grnd=271.35
+  real, dimension(klon) :: zx_sl
+  integer i
+  real, allocatable, dimension(:), save :: tmp_flux_o, tmp_flux_g
+  real, allocatable, dimension(:), save :: tmp_radsol
+  real, allocatable, dimension(:,:), save :: tmp_pctsrf_slab
+  real, allocatable, dimension(:), save :: tmp_seaice
 
 ! Local
@@ -287,4 +307,72 @@
   tsurf_new = 999999.
   alblw = 999999.
+
+!IM: "slab" ocean; initialisations
+  flux_o = 0.
+  flux_g = 0.
+!
+    if (.not. allocated(tmp_flux_o)) then
+      allocate(tmp_flux_o(klon), stat = error)
+      DO i=1, knon
+       tmp_flux_o(knindex(i))=flux_o(i)
+      ENDDO
+      if (error /= 0) then
+        abort_message='Pb allocation tmp_flux_o'
+        call abort_gcm(modname,abort_message,1)
+      endif
+    endif
+    if (.not. allocated(tmp_flux_g)) then  
+      allocate(tmp_flux_g(klon), stat = error)
+      DO i=1, knon
+       tmp_flux_g(knindex(i))=flux_g(i)
+      ENDDO
+      if (error /= 0) then
+        abort_message='Pb allocation tmp_flux_g'
+        call abort_gcm(modname,abort_message,1)
+      endif
+    endif
+    if (.not. allocated(tmp_radsol)) then  
+      allocate(tmp_radsol(klon), stat = error)
+      if (error /= 0) then
+        abort_message='Pb allocation tmp_radsol'
+        call abort_gcm(modname,abort_message,1)
+      endif
+    endif
+    DO i=1, knon
+     tmp_radsol(knindex(i))=radsol(i)
+    ENDDO
+    if (.not. allocated(tmp_pctsrf_slab)) then
+      allocate(tmp_pctsrf_slab(klon,nbsrf), stat = error)
+      if (error /= 0) then
+        abort_message='Pb allocation tmp_pctsrf_slab'
+        call abort_gcm(modname,abort_message,1)
+      endif
+    DO i=1, klon
+     tmp_pctsrf_slab(i,1:nbsrf)=pctsrf(i,1:nbsrf)
+    ENDDO
+    endif
+!
+    if (.not. allocated(tmp_seaice)) then
+      allocate(tmp_seaice(klon), stat = error)
+      if (error /= 0) then
+        abort_message='Pb allocation tmp_seaice'
+        call abort_gcm(modname,abort_message,1)
+      endif
+    DO i=1, klon
+     tmp_seaice(i)=seaice(i)
+    ENDDO
+    endif
+!
+    if (.not. allocated(tmp_tslab)) then
+      allocate(tmp_tslab(klon), stat = error)
+      if (error /= 0) then
+        abort_message='Pb allocation tmp_tslab'
+        call abort_gcm(modname,abort_message,1)
+      endif
+    endif
+    DO i=1, klon
+     tmp_tslab(i)=tslab(i)
+    ENDDO
+!
 ! Aiguillage vers les differents schemas de surface
 
@@ -465,6 +553,9 @@
       & pctsrf_new)
 
-!    else if (ocean == 'slab  ') then
-!      call interfoce(nisurf)
+!IM: "slab" ocean
+     else if (ocean == 'slab  ') then
+      tsurf_new = tsurf
+      pctsrf_new = tmp_pctsrf_slab
+!
     else                              ! lecture conditions limites
       call interfoce(itime, dtime, jour, & 
@@ -504,4 +595,12 @@
 !!$      endwhere
 
+!IM: flux ocean-atmosphere utile pour le "slab" ocean
+    DO i=1, knon
+     zx_sl(i) = RLVTT
+     if (tsurf_new(i) .LT. RTT) zx_sl(i) = RLSTT
+     flux_o(i) = fluxsens(i)-evap(i)*zx_sl(i)
+     tmp_flux_o(knindex(i)) = flux_o(i)
+     tmp_radsol(knindex(i))=radsol(i)
+    ENDDO
 !
 ! 2eme appel a interfoce pour le cumul des champs (en particulier
@@ -524,7 +623,18 @@
       & pctsrf_new)
 
-!    else if (ocean == 'slab  ') then
-!      call interfoce(nisurf)
-
+!IM: "slab" ocean 
+    else if (ocean == 'slab  ') then
+!
+       seaice=tmp_seaice
+       cumul = .true.
+       call interfoce(klon, debut, itime, dtime, jour, &
+     & tmp_radsol, tmp_flux_o, tmp_flux_g, pctsrf, &
+     & tslab, seaice, pctsrf_new)
+!
+       tmp_pctsrf_slab=pctsrf_new
+       DO i=1, knon
+        tsurf_new(i)=tslab(knindex(i))
+       ENDDO !i
+!
     endif
 
@@ -585,6 +695,31 @@
       beta = 1.0
 
-!    else if (ocean == 'slab  ') then
-!      call interfoce(nisurf)
+!IM: "slab" ocean
+    else if (ocean == 'slab  ') then
+     pctsrf_new=tmp_pctsrf_slab
+!
+     DO ii = 1, knon
+      tsurf_new(ii) = tsurf(ii)
+      IF (pctsrf_new(knindex(ii),nisurf) < EPSFRA) then
+       snow(ii) = 0.0
+       tsurf_new(ii) = RTT - 1.8
+       IF (soil_model) tsoil(ii,:) = RTT -1.8
+      ENDIF
+     ENDDO
+
+     CALL calbeta(dtime, nisurf, knon, snow, qsol, beta, capsol, dif_grnd)
+      
+     IF (soil_model) THEN 
+      CALL soil(dtime, nisurf, knon,snow, tsurf_new, tsoil,soilcap, soilflux)
+      cal(1:knon) = RCPD / soilcap(1:knon)
+      radsol(1:knon) = radsol(1:knon)  + soilflux(1:knon)
+     ELSE 
+      dif_grnd = 1.0 / tau_gl
+      cal = RCPD * calice
+      WHERE (snow > 0.0) cal = RCPD * calsno 
+     ENDIF
+     tsurf_temp = tsurf_new
+     beta = 1.0
+!
     ELSE
 !                              ! lecture conditions limites
@@ -596,5 +731,7 @@
 !IM cf LF
       DO ii = 1, knon
-       IF (pctsrf_new(ii,nisurf) < EPSFRA) then
+       tsurf_new(ii) = tsurf(ii)
+!IMbad IF (pctsrf_new(ii,nisurf) < EPSFRA) then
+       IF (pctsrf_new(knindex(ii),nisurf) < EPSFRA) then
           snow(ii) = 0.0
 !IM cf LF/JLD         tsurf(ii) = RTT - 1.8
@@ -617,5 +754,6 @@
          WHERE (snow > 0.0) cal = RCPD * calsno 
       ENDIF
-      tsurf_temp = tsurf
+!IMbadtsurf_temp = tsurf
+      tsurf_temp = tsurf_new
       beta = 1.0
     ENDIF
@@ -627,4 +765,27 @@
          &   petAcoef, peqAcoef, petBcoef, peqBcoef, &
          &   tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l)
+!
+!IM: flux entre l'ocean et la glace de mer pour le "slab" ocean
+    DO i = 1, knon
+     flux_g(i) = 0.0
+!
+!IM: faire dependre le coefficient de conduction de la glace de mer
+!    de l'epaisseur de la glace de mer, dans l'hypothese ou le coeff.
+!    actuel correspond a 3m de glace de mer, cf. L.Li
+!
+!      IF(1.EQ.0) THEN
+!       IF(siceh(i).GT.0.) THEN
+!        new_dif_grnd(i) = dif_grnd(i)*3./siceh(i)
+!       ELSE
+!        new_dif_grnd(i) = 0.
+!       ENDIF
+!      ENDIF !(1.EQ.0) THEN
+!
+     IF (cal(i).GT.1.0e-15) flux_g(i)=(tsurf_new(i)-t_grnd) &
+    &                          * dif_grnd(i) *RCPD/cal(i)
+!   &                          * new_dif_grnd(i) *RCPD/cal(i)
+      tmp_flux_g(knindex(i))=flux_g(i)
+      tmp_radsol(knindex(i))=radsol(i)
+    ENDDO
 
     IF (ocean /= 'couple') THEN
@@ -744,9 +905,10 @@
      alb_new(1 : knon)  = alb_neig(1 : knon)*zfra(1:knon) + &
     &                     0.6 * (1.0-zfra(1:knon))
-!IM cf FH/GK     alb_new(1 : knon)  = 0.6
+!
+!IM: plusieurs choix/tests sur l'albedo des "glaciers continentaux"
+!       alb_new(1 : knon)  = 0.6 !IM cf FH/GK 
 !       alb_new(1 : knon)  = 0.82
-!IM cf JLD/ GK
-!IM: 211003 Ksta0.77      alb_new(1 : knon)  = 0.77
-!IM: KstaTER0.8 & LMD_ARMIP5    alb_new(1 : knon)  = 0.8
+!       alb_new(1 : knon)  = 0.77 !211003 Ksta0.77
+!       alb_new(1 : knon)  = 0.8 !KstaTER0.8 & LMD_ARMIP5
 !IM: KstaTER0.77 & LMD_ARMIP6    
         alb_new(1 : knon)  = 0.77
@@ -1137,4 +1299,10 @@
       resolution(igrid,2) = cvfi(ij)
     enddo  
+!IM tester la resolution que recoit Orchidee
+    IF((maxval(resolution(:,2)) == 0.).OR. &
+   &   (maxval(resolution(:,1)) == 0.)) THEN
+     abort_message='STOP interfsol : resolution recue par Orchidee = 0.'
+     call abort_gcm(modname,abort_message,1)
+    ENDIF
 
   endif                          ! (fin debut) 
@@ -1187,5 +1355,7 @@
 
 !IM cf. JP +++
-  swdown_vrai(1:knon) = swnet(1:knon)/(1. - albedo_keep(1:knon))
+!IM swdown_vrai(1:knon) = swnet(1:knon)/(1. - albedo_keep(1:knon))
+!IM modification faite dans clmain
+    swdown_vrai(1:knon) = swdown(1:knon)
 !IM cf. JP ---
 
@@ -1887,21 +2057,181 @@
 !#########################################################################
 !
-
-  SUBROUTINE interfoce_slab(nisurf)
-
-! Cette routine sert d'interface entre le modele atmospherique et un 
-! modele de 'slab' ocean
-!
-! L. Fairhead 02/2000
+   SUBROUTINE interfoce_slab(klon, debut, itap, dtime, ijour, &
+ & radsol, fluxo, fluxg, pctsrf, &
+ & tslab, seaice, pctsrf_slab)
+!
+! Cette routine calcule la temperature d'un slab ocean, la glace de mer 
+! et les pourcentages de la maille couverte par l'ocean libre et/ou 
+! la glace de mer pour un "slab" ocean de 50m
+!
+! I. Musat 04.02.2005
 !
 ! input:
-!   nisurf       index de la surface a traiter (1 = sol continental)
-!
-! output:
-!
-
+!   klon         nombre total de points de grille
+!   debut        logical: 1er appel a la physique
+!   itap         numero du pas de temps
+!   dtime        pas de temps de la physique (en s)
+!   ijour        jour dans l'annee en cours
+!   radsol       rayonnement net au sol (LW + SW)
+!   fluxo        flux turbulent (sensible + latent) sur les mailles oceaniques 
+!   fluxg        flux de conduction entre la surface de la glace de mer et l'ocean
+!   pctsrf       tableau des pourcentages de surface de chaque maille
+! output: 
+!   tslab        temperature de l'ocean libre
+!   seaice       glace de mer (kg/m2)
+!   pctsrf_slab  "pourcentages" (valeurs entre 0. et 1.) surfaces issus du slab
+!
+#include "indicesol.inc"
+#include "clesphys.inc"
 ! Parametres d'entree
-  integer, intent(IN) :: nisurf
-
+  integer, intent(IN) :: klon
+  logical, intent(IN) :: debut
+  INTEGER, intent(IN) :: itap
+  REAL, intent(IN) :: dtime
+  INTEGER, intent(IN) :: ijour
+  REAL, dimension(klon), intent(IN) :: radsol
+  REAL, dimension(klon), intent(IN) :: fluxo
+  REAL, dimension(klon), intent(IN) :: fluxg
+  real, dimension(klon, nbsrf), intent(IN) :: pctsrf
+! Parametres de sortie
+  real, dimension(klon), intent(INOUT) :: tslab
+  real, dimension(klon), intent(INOUT)        :: seaice ! glace de mer (kg/m2)
+  real, dimension(klon, nbsrf), intent(OUT) :: pctsrf_slab
+!
+! Variables locales :
+  INTEGER, save :: lmt_pas, julien, idayvrai
+  REAL, parameter :: unjour=86400.
+  real, allocatable, dimension(:), save :: tmp_tslab, tmp_seaice
+  REAL, allocatable, dimension(:), save :: slab_bils
+  REAL, allocatable, dimension(:), save :: lmt_bils
+  logical,save              :: check = .false.
+!
+  REAL, parameter :: cyang=50.0 * 4.228e+06 ! capacite calorifique volumetrique de l'eau J/(m2 K)
+  REAL, parameter :: cbing=0.334e+05        ! J/kg
+  real, dimension(klon)                 :: siceh !hauteur de la glace de mer (m)
+  INTEGER :: i
+  integer :: sum_error, error
+  REAL :: zz, za, zb
+!
+  character (len = 80) :: abort_message
+  character (len = 20) :: modname = 'interfoce_slab'
+!
+  julien = MOD(ijour,360)
+  sum_error = 0
+  IF (debut) THEN
+   allocate(slab_bils(klon), stat = error); sum_error = sum_error + error
+   allocate(lmt_bils(klon), stat = error); sum_error = sum_error + error
+   allocate(tmp_tslab(klon), stat = error); sum_error = sum_error + error
+   allocate(tmp_seaice(klon), stat = error); sum_error = sum_error + error
+   if (sum_error /= 0) then
+    abort_message='Pb allocation var. slab_bils,lmt_bils,tmp_tslab,tmp_seaice'
+    call abort_gcm(modname,abort_message,1)
+   endif
+   tmp_tslab=tslab
+   tmp_seaice=seaice
+   lmt_pas = nint(86400./dtime * 1.0) ! pour une lecture une fois par jour
+!
+   IF (check) THEN
+    PRINT*,'interfoce_slab klon, debut, itap, dtime, ijour, &
+ &          lmt_pas ', klon, debut, itap, dtime, ijour, &
+ &          lmt_pas
+   ENDIF !check
+!
+   PRINT*, '************************'
+   PRINT*, 'SLAB OCEAN est actif, prenez precautions !'
+   PRINT*, '************************'
+!
+! a mettre un slab_bils aussi en force !!!
+!
+    DO i = 1, klon
+     slab_bils(i) = 0.0
+    ENDDO
+!
+   ENDIF !debut
+   pctsrf_slab(1:klon,1:nbsrf) = pctsrf(1:klon,1:nbsrf)
+!
+! lecture du bilan au sol lmt_bils issu d'une simulation forcee en debut de journee
+! 
+   IF (MOD(itap,lmt_pas) .EQ. 1) THEN !1er pas de temps de la journee
+    idayvrai = ijour
+    CALL condsurf(julien,idayvrai, lmt_bils)
+   ENDIF !(MOD(itap-1,lmt_pas) .EQ. 0) THEN
+
+   DO i = 1, klon
+     IF((pctsrf_slab(i,is_oce).GT.epsfra).OR. &
+     &  (pctsrf_slab(i,is_sic).GT.epsfra)) THEN
+!
+! fabriquer de la glace si congelation atteinte:
+!
+      IF (tmp_tslab(i).LT.(RTT-1.8)) THEN
+       zz =  (RTT-1.8)-tmp_tslab(i)
+       tmp_seaice(i) = tmp_seaice(i) + cyang/cbing * zz
+       seaice(i) = tmp_seaice(i)
+       tmp_tslab(i) = RTT-1.8
+      ENDIF
+!
+! faire fondre de la glace si temperature est superieure a 0:
+!
+      IF ((tmp_tslab(i).GT.RTT) .AND. (tmp_seaice(i).GT.0.0)) THEN
+       zz = cyang/cbing * (tmp_tslab(i)-RTT)
+       zz = MIN(zz,tmp_seaice(i))
+       tmp_seaice(i) = tmp_seaice(i) - zz
+       seaice(i) = tmp_seaice(i)
+       tmp_tslab(i) = tmp_tslab(i) - zz*cbing/cyang
+      ENDIF
+!
+! limiter la glace de mer a 10 metres (10000 kg/m2)
+!
+      IF(tmp_seaice(i).GT.45.) THEN
+       tmp_seaice(i) = MIN(tmp_seaice(i),10000.0)
+      ELSE
+       tmp_seaice(i) = 0. 
+      ENDIF
+      seaice(i) = tmp_seaice(i)
+      siceh(i)=tmp_seaice(i)/1000. !en metres
+!
+! determiner la nature du sol (glace de mer ou ocean libre):
+!
+! on fait dependre la fraction de seaice "pctsrf(i,is_sic)" 
+! de l'epaisseur de seaice :
+! pctsrf(i,is_sic)=1. si l'epaisseur de la glace de mer est >= a 20cm
+! et pctsrf(i,is_sic) croit lineairement avec seaice de 0. a 20cm d'epaisseur
+!
+      pctsrf_slab(i,is_sic)=MIN(siceh(i)/0.20, &
+     &                      1.-(pctsrf_slab(i,is_ter)+pctsrf_slab(i,is_lic)))
+      pctsrf_slab(i,is_oce)=1.0 - &
+     &      (pctsrf_slab(i,is_ter)+pctsrf_slab(i,is_lic)+pctsrf_slab(i,is_sic))
+     ENDIF !pctsrf
+   ENDDO
+!
+! Calculer le bilan du flux de chaleur au sol :
+!
+   DO i = 1, klon
+    za = radsol(i) + fluxo(i)
+    zb = fluxg(i)
+    IF((pctsrf_slab(i,is_oce).GT.epsfra).OR. &
+   &   (pctsrf_slab(i,is_sic).GT.epsfra)) THEN
+     slab_bils(i)=slab_bils(i)+(za*pctsrf_slab(i,is_oce) &
+   &             +zb*pctsrf_slab(i,is_sic))/ FLOAT(lmt_pas)
+    ENDIF
+   ENDDO !klon
+!
+! calcul tslab 
+!
+   IF (MOD(itap,lmt_pas).EQ.0) THEN !fin de journee
+    DO i = 1, klon
+      IF ((pctsrf_slab(i,is_oce).GT.epsfra).OR. &
+     &    (pctsrf_slab(i,is_sic).GT.epsfra)) THEN
+       tmp_tslab(i) = tmp_tslab(i) + &
+     & (slab_bils(i)-lmt_bils(i)) &
+     &                         /cyang*unjour
+! on remet l'accumulation a 0
+       slab_bils(i) = 0.
+      ENDIF !pctsrf
+    ENDDO !klon
+   ENDIF !(MOD(itap,lmt_pas).EQ.0) THEN
+!
+   tslab = tmp_tslab
+   seaice = tmp_seaice
   END SUBROUTINE interfoce_slab
 !
Index: /LMDZ4/trunk/libf/phylmd/moy_undefSTD.F
===================================================================
--- /LMDZ4/trunk/libf/phylmd/moy_undefSTD.F	(revision 644)
+++ /LMDZ4/trunk/libf/phylmd/moy_undefSTD.F	(revision 644)
@@ -0,0 +1,79 @@
+      SUBROUTINE moy_undefSTD(nlevSTD,itap,
+     $           ecrit_day,ecrit_mth,ecrit_hf2mth,
+     $           tnondef,tsumSTD)
+      IMPLICIT none
+c
+c====================================================================
+c
+c I. Musat : 09.2004
+c
+c Moyenne - a des frequences differentes - des valeurs bien definies
+c         (.NE.1.E+20) des variables interpolees a un niveau de
+c         pression.
+c 1) les variables de type "day" (nout=1) ou "mth" (nout=2) sont sommees
+c    tous les pas de temps de la physique
+c
+c 2) les variables de type "NMC" (nout=3) sont calculees a partir
+c    des valeurs instantannees toutes les 6 heures
+c
+c
+c NB: mettre "inst(X)" dans le write_histXXX.h !
+c====================================================================
+#include "dimensions.h"
+      integer jjmp1
+      parameter (jjmp1=jjm+1-1/jjm)
+#include "dimphy.h"
+c
+c variables Input
+      INTEGER nlevSTD, klevSTD, itap
+      PARAMETER(klevSTD=17)
+      INTEGER ecrit_day, ecrit_mth, ecrit_hf2mth
+c
+c variables locales
+      INTEGER i, k, nout
+      PARAMETER(nout=3) !nout=1 day/nout=2 mth/nout=3 NMC
+c
+c variables Output
+      REAL tnondef(klon,klevSTD,nout)
+      REAL tsumSTD(klon,klevSTD,nout)
+c
+c calcul 1 fois par jour
+c
+      IF(MOD(itap,ecrit_day).EQ.0) THEN
+       DO k=1, nlevSTD
+        DO i=1, klon
+         IF(tnondef(i,k,1).NE.FLOAT(ecrit_day)) THEN
+          tsumSTD(i,k,1)=tsumSTD(i,k,1)/
+     $    (FLOAT(ecrit_day)-tnondef(i,k,1))
+         ELSE
+          tsumSTD(i,k,1)=1.E+20
+         ENDIF !tnondef
+        ENDDO !i
+       ENDDO !k
+      ENDIF !MOD(itap,ecrit_day).EQ.0
+c
+c calcul 1 fois par mois
+c
+      IF(MOD(itap,ecrit_mth).EQ.0) THEN
+       DO k=1, nlevSTD
+        DO i=1, klon
+         IF(tnondef(i,k,2).NE.FLOAT(ecrit_mth)) THEN
+          tsumSTD(i,k,2)=tsumSTD(i,k,2)/
+     $    (FLOAT(ecrit_mth)-tnondef(i,k,2))
+         ELSE
+          tsumSTD(i,k,2)=1.E+20
+         ENDIF !tnondef
+c
+         IF(tnondef(i,k,3).NE.FLOAT(ecrit_hf2mth)) THEN
+          tsumSTD(i,k,3)=tsumSTD(i,k,3)/
+     $    (FLOAT(ecrit_hf2mth)-tnondef(i,k,3))
+         ELSE
+          tsumSTD(i,k,3)=1.E+20
+         ENDIF !tnondef
+c
+        ENDDO !i
+       ENDDO !k
+      ENDIF !MOD
+c
+      RETURN
+      END  
